import java.math.RoundingMode;
import java.math.BigDecimal;

public class Simulation {

    private Dice dice;
    private Bins bin;
    private int rolls = 0;

    public Simulation(int numberOfDice, int diceSides, int timesROlled){
        this.dice = new Dice(numberOfDice, diceSides);
        this.bin = new Bins(numberOfDice, diceSides);
        this.rolls = timesROlled;
    }

    public static double round(double value, int places) {
        if (places < 0) throw new IllegalArgumentException();

        BigDecimal bd = new BigDecimal(value);
        bd = bd.setScale(places, RoundingMode.HALF_UP);
        return bd.doubleValue();
    }

    //method to run the dice simulation
    public void runSimulation()
    {
        //for each amount of time we roll
        for(int i = 0; i < this.rolls; i ++){
            //roll the dice and store the values
            int sum = this.dice.roll();
            //store the sum in the bin
            bin.addToBin(sum);
        }
    }

    //method to print the results of the roll
    public void printResult(){
        //store the results of the bin
        int[] results = this.bin.getResults();
        //loop through the bin
        for(int i = 0; i < this.bin.getResults().length; i ++)
        {
            //for each value in the bin
            int currentResult = this.bin.getResults()[i];
            //get the statistics
            double stats = ((double)currentResult/(double)this.rolls);
            //round the statistic to two decimal places
            stats = round(stats, 2);
            //create the string that will output the information
            String result = "index of the array: " +i + " | value rolled : " + (i + this.dice.getAmount()) + " | amount of times this value was rolled: " + currentResult + " | percent : " + stats + " : ";
            //conver the percentage to an integer

            for(int m = 0; m < stats * 100.0; m ++){
                result += "*";
            }
            System.out.println(result);
        }
    }
}
