import org.junit.Assert;
import org.junit.Test;

public class TestClass {

    //BIN TESTING

    @Test
    public void test01()
    {
        //GIVEN
        //initialize the amount of rolls to 100;
        int rollAmount = 100;
        //create a new dice to test the bin;
        Dice dice = new Dice(1, 6);
        //create a new bin to test
        Bins bin = new Bins(1, 6);
        boolean expted = true;
        boolean actual = false;
        int counter = 0;

        //WHEN
        //loop one headred times
        for(int i = 0; i < rollAmount; i++)
        {
            //create a new random number between 1 and 6 each time
            int random = (int) (Math.floor(Math.random() * 6) + 1);
            //add it to the bin to test addToBin
            bin.addToBin(random);
        }
        //loop for each result in the bin // testing getResults();
        for(int m = 0; m < bin.getResults().length; m++)
        {
            //store the current result
            int binresult = bin.getResults()[m];
            //if the result is not a negative number, and all results are less than
            //the max amount of results
            if(binresult >= 0 && binresult < 100)
            {
                //increase the counter
                counter ++;
            }
        }
        //if the counter was increased for every iteration
        if(counter == bin.getResults().length)
        {
            //then pass the test
            actual = true;
        }
        Assert.assertEquals(expted, actual);
    }

    //DICE TESTING

    @Test
    public void test02() {
        //GIVEN
        //amount of times rolling
        int rollAmount = 100;
        //amount of dice being rolled
        int amountOfDice = 3;
        //sum of the dice roll
        int sum = 0;
        //dice to be rolled
        Dice dice = new Dice(amountOfDice, 6);
        //bin results will be stored in
        Bins bin = new Bins(amountOfDice, 6);
        //result to pass the test
        boolean expected = true;
        //default result
        boolean result = false;

        //WHEN
        //perform 100 rolls, testing every roll
        for(int i = 0; i < rollAmount; i ++)
        {
            //reset the sum each time it is rolled
            sum = 0;
            //roll the dice and collect the sum
            sum = dice.roll();
            //check if the roll is between the correct numbers
            bin.addToBin(sum);
            if(sum >= 3 && sum <= 18)
            {
                result = true;

            }
        }

        //RESULT
        Assert.assertEquals(expected, result);
    }

    @Test
    public void test03() {
        //GIVEN
        //amount of times rolling
        int rollAmount = 100;
        //amount of dice being rolled
        int amountOfDice = 100;
        //sum of the dice roll
        int sum = 0;
        //dice to be rolled
        Dice dice = new Dice(amountOfDice, 6);
        //bin results will be stored in
        Bins bin = new Bins(amountOfDice, 6);
        //result to pass the test
        boolean expected = true;
        //default result
        boolean result = false;

        //WHEN
        //perform 100 rolls, testing every roll
        for(int i = 0; i < rollAmount; i ++)
        {
            //reset the sum each time it is rolled
            sum = 0;
            //roll the dice and collect the sum
            sum = dice.roll();
            //check if the roll is between the correct numbers
            //at least 1 for every dice, and 600 for if every dice landed 6
            if(sum >= dice.getAmount() && sum <= 600)
            {
                result = true;
            }
        }

        //RESULT
        Assert.assertEquals(expected, result);
    }

    @Test
    public void test04() {
        //GIVEN
        //amount of times rolling
        int rollAmount = 10000;
        //amount of dice being rolled
        int amountOfDice = 100;
        //sum of the dice roll
        int sum = 0;
        //dice to be rolled
        Dice dice = new Dice(amountOfDice, 100);
        //bin results will be stored in
        Bins bin = new Bins(amountOfDice, 100);
        //result to pass the test
        boolean expected = true;
        //default result
        boolean result = false;

        //WHEN
        //perform 100 rolls, testing every roll
        for(int i = 0; i < rollAmount; i ++)
        {
            //reset the sum each time it is rolled
            sum = 0;
            //roll the dice and collect the sum
            sum = dice.roll();
            //check if the roll is between the correct numbers
            //at least 1 for every dice, and 10000 for if every dice landed 100
            if(sum >= dice.getAmount() && sum <= 10000)
            {
                result = true;
            }
        }

        //RESULT
        Assert.assertEquals(expected, result);
    }
}

